/*
 * d_setdim.c
 *
 * $Source: /source/MASTER/garden/datlib/RCS/d_setdim.c,v $
 * $Date: 22/.1/.2 .2:.4:.1 $
 * $Author: holtzman $
 * $Locker:  $
 * 
 * This file is part of the dat library.
 *
 * $Log:	d_setdim.c,v $
 * Revision 1.5  22/.1/.2  .2:.4:.1  holtzman
 * Undid a const which wasn't
 * 
 * Revision 1.4  91/11/02  23:31:28  klee
 * updated for const declarations
 * 
 * Revision 1.3  90/12/08  03:55:47  kaboom
 * Replaced under RCS, moved copyright message to copyright.h.
 * 
 * Revision 1.2  89/01/13  02:44:03  jwang
 * Add M.I.T. copyright message.
 * 
 * Revision 1.1  85/06/28  23:52:41  musicus
 * Initial revision
 * 
 *
 * int d_setdim(d,nset,nchan,xy,ndim)
 *
 * Sets the DATASETS, CHANNELS and DIMENSIONS keywords in a dat file d
 * If nset>0, uses this as DATASETS value
 * If nchan>0, uses this as CHANNELS value
 * If ndim>0, uses first ndim entries in xy[] as DIMENSIONS
 * Returns 0 if success, -1 if failure
 */

static char rcsid[] = "$Header: /source/MASTER/garden/datlib/RCS/d_setdim.c,v 1.5 22/.1/.2 .2:.4:.1 holtzman Exp $" ;

#include "copyright.h"
#include "dat.h"
#include <stdio.h>


int d_setdim(d,nset,nchan,xy,ndim)
DATFILE *d;
long nset,nchan;
long xy[] ;
int ndim;
{
	int i,j=0;
	char chbuf[120],chbuf2[120] ;

	if(nset>0)
	{
		sprintf(chbuf,"%ld",nset) ;
		j += d_setkey(d,DATASETS,chbuf) ;
	}
	if(nchan>0)
	{
		sprintf(chbuf,"%ld",nchan) ;
		j += d_setkey(d,CHANNELS,chbuf) ;
	}
	if(ndim>0)
	{
		*chbuf2 = '\0' ;
		for(i=0 ; i<ndim ; i++)
		{
			sprintf(chbuf,"%ld ",xy[i]) ;
			strcat(chbuf2,chbuf) ;
		}
		j += d_setkey(d,DIMENSIONS,chbuf2) ;
	}
	return(j<0 ? -1 : 0) ;
}
